diff --git a/src/tspi/rpc/tcstp/rpc.c b/src/tspi/rpc/tcstp/rpc.c
index 963da1f..a193d0e 100644
--- a/src/tspi/rpc/tcstp/rpc.c
+++ b/src/tspi/rpc/tcstp/rpc.c
@@ -8,14 +8,24 @@
  *
  */
 
+#ifdef WIN32
+#include <ws2tcpip.h>
+#include <windows.h>
+#endif
+#ifndef WIN32
 #include <unistd.h>
+#endif
 #include <errno.h>
 #include <string.h>
+#ifndef WIN32
 #include <sys/socket.h>
+#endif
 #include <sys/types.h>
+#ifndef WIN32
 #include <netinet/in.h>
 #include <arpa/inet.h>
 #include <netdb.h>
+#endif
 #include <stdlib.h>
 #include <stdio.h>
 #include <assert.h>
@@ -31,7 +41,9 @@
 #include "tcsd_wrap.h"
 #include "obj.h"
 #include "rpc_tcstp_tsp.h"
-
+#ifdef WIN32
+#include "libc_interface.h"
+#endif
 
 void
 initData(struct tcsd_comm_data *comm, int parm_count)
@@ -304,7 +316,7 @@ recv_from_socket(int sock, void *buffer, int size)
 
 	while (recv_total < size) {
 		errno = 0;
-		if ((recv_size = recv(sock, buffer+recv_total, size-recv_total, 0)) <= 0) {
+		if ((recv_size = recv(sock, (char *)buffer+recv_total, size-recv_total, 0)) <= 0) {
 			if (recv_size < 0) {
 				if (errno == EINTR)
 					continue;
@@ -327,7 +339,7 @@ send_to_socket(int sock, void *buffer, int size)
 	int send_size = 0, send_total = 0;
 
 	while (send_total < size) {
-		if ((send_size = send(sock, buffer+send_total, size-send_total, 0)) < 0) {
+		if ((send_size = send(sock, (char *)buffer+send_total, size-send_total, 0)) < 0) {
 			LogError("Socket send connection error: %s.", strerror(errno));
 			return -1;
 		}
@@ -348,6 +360,16 @@ send_init(struct host_table_entry *hte)
 	struct sockaddr_in addr;
 	struct hostent *hEnt = NULL;
 
+#ifdef WIN32
+	WSADATA wsaData;
+	
+	// Initialize Winsock
+	result = WSAStartup(MAKEWORD(2,2), &wsaData);
+	if(result) {
+		LogError("Error when initializing the WINSOCK library");
+		return TSPERR(TSS_E_COMM_FAILURE);
+	}
+#endif
 	sd = socket(PF_INET, SOCK_STREAM, 0);
 	if (sd == -1) {
 		LogError("socket: %s", strerror(errno));
@@ -432,6 +454,9 @@ send_init(struct host_table_entry *hte)
 
 err_exit:
 	close(sd);
+#ifdef WIN32
+	WSACleanup();
+#endif
 	return result;
 }
 
diff --git a/src/tspi/spi_utils.c b/src/tspi/spi_utils.c
index de80bc1..0ff9373 100644
--- a/src/tspi/spi_utils.c
+++ b/src/tspi/spi_utils.c
@@ -12,9 +12,16 @@
 #include <stdlib.h>
 #include <stdio.h>
 #include <string.h>
+#ifndef WIN32
 #include <unistd.h>
+#endif
+
 #include <sys/types.h>
+#ifndef WIN32
 #include <sys/mman.h>
+#else
+#include <time.h>
+#endif
 #include <errno.h>
 
 #include "trousers/tss.h"
@@ -26,11 +33,308 @@
 #include "tsplog.h"
 #include "obj.h"
 
+#ifdef WIN32
+#include "win32dep.h"
+#endif
 
 TSS_UUID NULL_UUID = { 0, 0, 0, 0, 0, { 0, 0, 0, 0, 0, 0 } };
 
 TSS_VERSION VERSION_1_1 = { 1, 1, 0, 0 };
 
+#ifdef WIN32
+struct tcs_api_table tcs_normal_api = {
+#ifdef TSS_BUILD_KEY
+	RPC_LoadKeyByBlob,
+	RPC_EvictKey,
+	RPC_CreateWrapKey,
+	RPC_GetPubKey,
+	RPC_OwnerReadInternalPub,
+#ifdef TSS_BUILD_CERTIFY
+	RPC_CertifyKey,
+#endif
+#endif
+#ifdef TSS_BUILD_OWN
+	RPC_OwnerClear,
+	RPC_ForceClear,
+#endif
+#ifdef TSS_BUILD_AUTH
+	RPC_OIAP,
+	RPC_OSAP,
+	RPC_TerminateHandle,
+#endif
+#ifdef TSS_BUILD_CHANGEAUTH
+	RPC_ChangeAuth,
+	RPC_ChangeAuthOwner,
+	RPC_ChangeAuthAsymStart,
+	RPC_ChangeAuthAsymFinish,
+#endif
+#ifdef TSS_BUILD_AIK
+	RPC_ActivateTPMIdentity,
+#endif
+#ifdef TSS_BUILD_PCR_EXTEND
+	RPC_Extend,
+	RPC_PcrRead,
+	RPC_PcrReset,
+#endif
+#ifdef TSS_BUILD_QUOTE
+	RPC_Quote,
+#endif
+#ifdef TSS_BUILD_QUOTE2
+	RPC_Quote2,
+#endif
+#ifdef TSS_BUILD_DIR
+	RPC_DirWriteAuth,
+	RPC_DirRead,
+#endif
+#ifdef TSS_BUILD_SEAL
+	RPC_Seal,
+	RPC_Sealx,
+	RPC_Unseal,
+#endif
+#ifdef TSS_BUILD_BIND
+	RPC_UnBind,
+#endif
+#ifdef TSS_BUILD_MIGRATION
+	RPC_CreateMigrationBlob,
+	RPC_ConvertMigrationBlob,
+	RPC_AuthorizeMigrationKey,
+#endif
+#ifdef TSS_BUILD_SIGN
+	RPC_Sign,
+#endif
+#ifdef TSS_BUILD_RANDOM
+	RPC_GetRandom,
+	RPC_StirRandom,
+#endif
+#ifdef TSS_BUILD_CAPS_TPM
+	RPC_GetTPMCapability,
+	RPC_SetCapability,
+	RPC_GetCapabilityOwner,
+#endif
+#ifdef TSS_BUILD_EK
+	RPC_CreateEndorsementKeyPair,
+	RPC_ReadPubek,
+	RPC_OwnerReadPubek,
+#endif
+#ifdef TSS_BUILD_SELFTEST
+	RPC_SelfTestFull,
+	RPC_CertifySelfTest,
+	RPC_GetTestResult,
+#endif
+#ifdef TSS_BUILD_ADMIN
+	RPC_DisablePubekRead,
+	RPC_SetOwnerInstall,
+	RPC_OwnerSetDisable,
+	RPC_ResetLockValue,
+	RPC_DisableOwnerClear,
+	RPC_DisableForceClear,
+	RPC_PhysicalDisable,
+	RPC_PhysicalEnable,
+	RPC_PhysicalSetDeactivated,
+	RPC_PhysicalPresence,
+	RPC_SetTempDeactivated,
+	RPC_SetTempDeactivated2,
+#endif
+#ifdef TSS_BUILD_MAINT
+	RPC_CreateMaintenanceArchive,
+	RPC_LoadMaintenanceArchive,
+	RPC_KillMaintenanceFeature,
+	RPC_LoadManuMaintPub,
+	RPC_ReadManuMaintPub,
+#endif
+#ifdef TSS_BUILD_DAA
+	RPC_DaaJoin,
+	RPC_DaaSign,
+#endif
+#ifdef TSS_BUILD_COUNTER
+	RPC_ReadCounter,
+	RPC_CreateCounter,
+	RPC_IncrementCounter,
+	RPC_ReleaseCounter,
+	RPC_ReleaseCounterOwner,
+#endif
+#ifdef TSS_BUILD_TICK
+	RPC_ReadCurrentTicks,
+	RPC_TickStampBlob,
+#endif
+#ifdef TSS_BUILD_NV
+	RPC_NV_DefineOrReleaseSpace,
+	RPC_NV_WriteValue,
+	RPC_NV_WriteValueAuth,
+	RPC_NV_ReadValue,
+	RPC_NV_ReadValueAuth,
+#endif
+#ifdef TSS_BUILD_AUDIT
+	RPC_SetOrdinalAuditStatus,
+	RPC_GetAuditDigest,
+	RPC_GetAuditDigestSigned,
+#endif
+#ifdef TSS_BUILD_TSS12
+	RPC_SetOperatorAuth,
+	RPC_FlushSpecific,
+#endif
+#ifdef TSS_BUILD_DELEGATION
+	RPC_Delegate_Manage,
+	RPC_Delegate_CreateKeyDelegation,
+	RPC_Delegate_CreateOwnerDelegation,
+	RPC_Delegate_LoadOwnerDelegation,
+	RPC_Delegate_ReadTable,
+	RPC_Delegate_UpdateVerificationCount,
+	RPC_Delegate_VerifyDelegation,
+	RPC_DSAP,
+#endif
+	RPC_FieldUpgrade,
+	RPC_SetRedirection,
+};
+
+#ifdef TSS_BUILD_TRANSPORT
+struct tcs_api_table tcs_transport_api = {
+#ifdef TSS_BUILD_KEY
+	Transport_LoadKeyByBlob,
+	Transport_EvictKey,
+	Transport_CreateWrapKey,
+	Transport_GetPubKey,
+	Transport_OwnerReadInternalPub,
+#ifdef TSS_BUILD_CERTIFY
+	Transport_CertifyKey,
+#endif
+#endif
+#ifdef TSS_BUILD_OWN
+	Transport_OwnerClear,
+	Transport_ForceClear,
+#endif
+#ifdef TSS_BUILD_AUTH
+	Transport_OIAP,
+	Transport_OSAP,
+	Transport_TerminateHandle,
+#endif
+#ifdef TSS_BUILD_CHANGEAUTH
+	Transport_ChangeAuth,
+	Transport_ChangeAuthOwner,
+	RPC_ChangeAuthAsymStart,
+	RPC_ChangeAuthAsymFinish,
+#endif
+#ifdef TSS_BUILD_AIK
+	Transport_ActivateTPMIdentity,
+#endif
+#ifdef TSS_BUILD_PCR_EXTEND
+	Transport_Extend,
+	Transport_PcrRead,
+	Transport_PcrReset,
+#endif
+#ifdef TSS_BUILD_QUOTE
+	Transport_Quote,
+#endif
+#ifdef TSS_BUILD_QUOTE2
+	Transport_Quote2,
+#endif
+#ifdef TSS_BUILD_DIR
+	Transport_DirWriteAuth,
+	Transport_DirRead,
+#endif
+#ifdef TSS_BUILD_SEAL
+	Transport_Seal,
+	Transport_Sealx,
+	Transport_Unseal,
+#endif
+#ifdef TSS_BUILD_BIND
+	Transport_UnBind,
+#endif
+#ifdef TSS_BUILD_MIGRATION
+	Transport_CreateMigrationBlob,
+	Transport_ConvertMigrationBlob,
+	Transport_AuthorizeMigrationKey,
+#endif
+#ifdef TSS_BUILD_SIGN
+	Transport_Sign,
+#endif
+#ifdef TSS_BUILD_RANDOM
+	Transport_GetRandom,
+	Transport_StirRandom,
+#endif
+#ifdef TSS_BUILD_CAPS_TPM
+	Transport_GetTPMCapability,
+	Transport_SetCapability,
+	Transport_GetCapabilityOwner,
+#endif
+#ifdef TSS_BUILD_EK
+	RPC_CreateEndorsementKeyPair,
+	RPC_ReadPubek,
+	RPC_OwnerReadPubek,
+#endif
+#ifdef TSS_BUILD_SELFTEST
+	Transport_SelfTestFull,
+	Transport_CertifySelfTest,
+	Transport_GetTestResult,
+#endif
+#ifdef TSS_BUILD_ADMIN
+	Transport_DisablePubekRead,
+	Transport_SetOwnerInstall,
+	Transport_OwnerSetDisable,
+	Transport_ResetLockValue,
+	Transport_DisableOwnerClear,
+	Transport_DisableForceClear,
+	Transport_PhysicalDisable,
+	Transport_PhysicalEnable,
+	Transport_PhysicalSetDeactivated,
+	Transport_PhysicalPresence,
+	Transport_SetTempDeactivated,
+	Transport_SetTempDeactivated2,
+#endif
+#ifdef TSS_BUILD_MAINT
+	Transport_CreateMaintenanceArchive,
+	Transport_LoadMaintenanceArchive,
+	Transport_KillMaintenanceFeature,
+	Transport_LoadManuMaintPub,
+	Transport_ReadManuMaintPub,
+#endif
+#ifdef TSS_BUILD_DAA
+	RPC_DaaJoin,
+	RPC_DaaSign,
+#endif
+#ifdef TSS_BUILD_COUNTER
+	Transport_ReadCounter,
+	RPC_CreateCounter,
+	RPC_IncrementCounter,
+	RPC_ReleaseCounter,
+	RPC_ReleaseCounterOwner,
+#endif
+#ifdef TSS_BUILD_TICK
+	Transport_ReadCurrentTicks,
+	Transport_TickStampBlob,
+#endif
+#ifdef TSS_BUILD_NV
+	Transport_NV_DefineOrReleaseSpace,
+	Transport_NV_WriteValue,
+	Transport_NV_WriteValueAuth,
+	Transport_NV_ReadValue,
+	Transport_NV_ReadValueAuth,
+#endif
+#ifdef TSS_BUILD_AUDIT
+	Transport_SetOrdinalAuditStatus,
+	Transport_GetAuditDigest,
+	Transport_GetAuditDigestSigned,
+#endif
+#ifdef TSS_BUILD_TSS12
+	Transport_SetOperatorAuth,
+	Transport_FlushSpecific,
+#endif
+#ifdef TSS_BUILD_DELEGATION
+	Transport_Delegate_Manage,
+	Transport_Delegate_CreateKeyDelegation,
+	Transport_Delegate_CreateOwnerDelegation,
+	Transport_Delegate_LoadOwnerDelegation,
+	Transport_Delegate_ReadTable,
+	Transport_Delegate_UpdateVerificationCount,
+	Transport_Delegate_VerifyDelegation,
+	Transport_DSAP,
+#endif
+	RPC_FieldUpgrade,
+	RPC_SetRedirection,
+};
+#endif
+
+#else
 struct tcs_api_table tcs_normal_api = {
 #ifdef TSS_BUILD_KEY
 	.LoadKeyByBlob = RPC_LoadKeyByBlob,
@@ -329,6 +633,7 @@ struct tcs_api_table tcs_transport_api = {
 	.SetRedirection = RPC_SetRedirection,
 };
 #endif
+#endif
 
 UINT16
 Decode_UINT16(BYTE * in)
@@ -421,6 +726,7 @@ UnloadBlob_AUTH(UINT64 *offset, BYTE *blob, TPM_AUTH *auth)
 	Trspi_UnloadBlob(offset, 20, blob, (BYTE *)&auth->HMAC);
 }
 
+#ifndef WIN32
 /* If alloc is true, we allocate a new buffer for the bytes and set *data to that.
  * If alloc is false, data is really a BYTE*, so write the bytes directly to that buffer */
 TSS_RESULT
@@ -457,3 +763,33 @@ get_local_random(TSS_HCONTEXT tspContext, TSS_BOOL alloc, UINT32 size, BYTE **da
 
 	return TSS_SUCCESS;
 }
+#else
+TSS_RESULT
+get_local_random(TSS_HCONTEXT tspContext, TSS_BOOL alloc, UINT32 size, BYTE **data)
+{
+	BYTE *buf = NULL;
+	size_t i;
+
+	static const char table16[]="0123456789abcdef";
+
+	if (alloc) {
+		buf = calloc_tspi(tspContext, size);
+		if (buf == NULL) {
+			LogError("malloc of %u bytes failed", size);
+			return TSPERR(TSS_E_OUTOFMEMORY);
+		}
+	} else
+		buf = (BYTE *)data;
+
+	Curl_srand();
+	
+	for (i=0; i<size; i++) {
+		buf[i] = table16[Curl_rand()%16];
+	}
+
+	if (alloc)
+		*data = buf;
+
+	return TSS_SUCCESS;  
+}
+#endif
diff --git a/src/tspi/tsp_auth.c b/src/tspi/tsp_auth.c
index 55b9ccf..1c41ae5 100755
--- a/src/tspi/tsp_auth.c
+++ b/src/tspi/tsp_auth.c
@@ -9,6 +9,9 @@
  */
 
 
+#ifdef WIN32
+#include <windows.h>
+#endif
 #include <stdlib.h>
 #include <stdio.h>
 #include <string.h>
@@ -73,11 +76,14 @@ secret_PerformAuth_OIAP(TSS_HOBJECT hAuthorizedObject,
 		if (result == TCPA_E_RESOURCES) {
 			int retry = 0;
 			do {
+#ifdef WIN32
+				Sleep(AUTH_RETRY_MILLISEC);
+#else
 				/* POSIX sleep time, { secs, nanosecs } */
 				struct timespec t = { 0, AUTH_RETRY_NANOSECS };
 
 				nanosleep(&t, NULL);
-
+#endif
 				result = OIAP(tspContext, &auth->AuthHandle, &auth->NonceEven);
 			} while (result == TCPA_E_RESOURCES && ++retry < AUTH_RETRY_COUNT);
 		}
@@ -404,11 +410,14 @@ OSAP_Calc(TSS_HCONTEXT tspContext, UINT16 EntityType, UINT32 EntityValue,
 		if (rc == TCPA_E_RESOURCES) {
 			int retry = 0;
 			do {
+#ifdef WIN32
+				Sleep(AUTH_RETRY_MILLISEC);
+#else
 				/* POSIX sleep time, { secs, nanosecs } */
 				struct timespec t = { 0, AUTH_RETRY_NANOSECS };
 
 				nanosleep(&t, NULL);
-
+#endif
 				rc = TCS_API(tspContext)->OSAP(tspContext, EntityType, EntityValue,
 							       &auth->NonceOdd, &auth->AuthHandle,
 							       &auth->NonceEven, &nonceEvenOSAP);
@@ -622,11 +631,14 @@ authsess_do_dsap(struct authsess *sess)
 		if (result == TCPA_E_RESOURCES) {
 			int retry = 0;
 			do {
+#ifdef WIN32
+				Sleep(AUTH_RETRY_MILLISEC);
+#else
 				/* POSIX sleep time, { secs, nanosecs } */
 				struct timespec t = { 0, AUTH_RETRY_NANOSECS };
 
 				nanosleep(&t, NULL);
-
+#endif
 				result = TCS_API(sess->tspContext)->DSAP(sess->tspContext,
 									 sess->entity_type,
 									 sess->obj_parent,
@@ -657,11 +669,14 @@ authsess_do_osap(struct authsess *sess)
 		if (result == TCPA_E_RESOURCES) {
 			int retry = 0;
 			do {
+#ifdef WIN32
+				Sleep(AUTH_RETRY_MILLISEC);
+#else
 				/* POSIX sleep time, { secs, nanosecs } */
 				struct timespec t = { 0, AUTH_RETRY_NANOSECS };
 
 				nanosleep(&t, NULL);
-
+#endif
 				result = TCS_API(sess->tspContext)->OSAP(sess->tspContext,
 									 sess->entity_type,
 									 sess->obj_parent,
@@ -774,7 +789,7 @@ authsess_xsap_init(TSS_HCONTEXT     tspContext,
 		   struct authsess  **xsess)
 {
 	TSS_RESULT result;
-	TSS_BOOL authdatausage = FALSE, req_auth = TRUE, get_child_auth = TRUE;
+	TSS_BOOL authdatausage = FALSE, req_auth = TRUE, get_child_auth = TRUE, secret_set = FALSE;
 	BYTE hmacBlob[2 * sizeof(TPM_DIGEST)];
 	UINT64 offset;
 	TSS_BOOL new_secret = TR_SECRET_CTX_NOT_NEW;
@@ -921,7 +936,10 @@ authsess_xsap_init(TSS_HCONTEXT     tspContext,
 					goto error;
 			}
 
-			if (!sess->hUsageChild) {
+			if ((result = obj_policy_is_secret_set(sess->hUsageChild, &secret_set)))
+				goto error;
+
+			if (!secret_set) {
 				result = TSPERR(TSS_E_TSP_AUTHREQUIRED);
 				goto error;
 			}
diff --git a/src/tspi/tsp_caps.c b/src/tspi/tsp_caps.c
index f06fbd6..2d6dc18 100644
--- a/src/tspi/tsp_caps.c
+++ b/src/tspi/tsp_caps.c
@@ -12,9 +12,14 @@
 #include <stdlib.h>
 #include <stdio.h>
 #include <string.h>
+#ifndef WIN32
 #include <unistd.h>
+#endif
+
 #include <sys/types.h>
+#ifndef WIN32
 #include <sys/mman.h>
+#endif
 #include <errno.h>
 
 #include "trousers/tss.h"
diff --git a/src/tspi/tsp_caps_tpm.c b/src/tspi/tsp_caps_tpm.c
index 1203dbe..b93ad8f 100644
--- a/src/tspi/tsp_caps_tpm.c
+++ b/src/tspi/tsp_caps_tpm.c
@@ -8,10 +8,15 @@
  *
  */
 
+#ifdef WIN32
+#include <windows.h>
+#endif
 #include <stdlib.h>
 #include <stdio.h>
 #include <string.h>
+#ifndef WIN32
 #include <inttypes.h>
+#endif
 
 #include "trousers/tss.h"
 #include "trousers/trousers.h"
diff --git a/src/tspi/tsp_ek.c b/src/tspi/tsp_ek.c
index 4c2ae4f..865e287 100644
--- a/src/tspi/tsp_ek.c
+++ b/src/tspi/tsp_ek.c
@@ -11,7 +11,9 @@
 #include <stdlib.h>
 #include <stdio.h>
 #include <string.h>
+#ifndef WIN32
 #include <inttypes.h>
+#endif
 
 #include "trousers/tss.h"
 #include "trousers/trousers.h"
diff --git a/src/tspi/tsp_get_flags.c b/src/tspi/tsp_get_flags.c
index f974052..f6b3208 100644
--- a/src/tspi/tsp_get_flags.c
+++ b/src/tspi/tsp_get_flags.c
@@ -12,9 +12,13 @@
 #include <stdlib.h>
 #include <stdio.h>
 #include <string.h>
+#ifndef WIN32
 #include <unistd.h>
+#endif
 #include <sys/types.h>
+#ifndef WIN32
 #include <sys/mman.h>
+#endif
 #include <errno.h>
 
 #include "trousers/tss.h"
diff --git a/src/tspi/tsp_maint.c b/src/tspi/tsp_maint.c
index 3e50ddd..7f8c466 100644
--- a/src/tspi/tsp_maint.c
+++ b/src/tspi/tsp_maint.c
@@ -11,7 +11,9 @@
 #include <stdlib.h>
 #include <stdio.h>
 #include <string.h>
+#ifndef WIN32
 #include <inttypes.h>
+#endif
 
 #include "trousers/tss.h"
 #include "trousers/trousers.h"
diff --git a/src/tspi/tsp_migration.c b/src/tspi/tsp_migration.c
index 9c83753..38d9a1d 100644
--- a/src/tspi/tsp_migration.c
+++ b/src/tspi/tsp_migration.c
@@ -11,7 +11,9 @@
 #include <stdlib.h>
 #include <stdio.h>
 #include <string.h>
+#ifndef WIN32
 #include <inttypes.h>
+#endif
 
 #include "trousers/tss.h"
 #include "trousers/trousers.h"
diff --git a/src/tspi/tsp_nv.c b/src/tspi/tsp_nv.c
index 511a6c9..63e3cee 100644
--- a/src/tspi/tsp_nv.c
+++ b/src/tspi/tsp_nv.c
@@ -11,7 +11,9 @@
 #include <stdlib.h>
 #include <stdio.h>
 #include <string.h>
+#ifndef WIN32
 #include <inttypes.h>
+#endif
 
 #include "trousers/tss.h"
 #include "trousers/trousers.h"
diff --git a/src/tspi/tsp_pcr.c b/src/tspi/tsp_pcr.c
index cc562d7..c5ed1da 100644
--- a/src/tspi/tsp_pcr.c
+++ b/src/tspi/tsp_pcr.c
@@ -9,12 +9,19 @@
  */
 
 
+#ifdef WIN32
+#include <windows.h>
+#endif
 #include <stdlib.h>
 #include <stdio.h>
 #include <string.h>
+#ifndef WIN32
 #include <unistd.h>
+#endif
 #include <sys/types.h>
+#ifndef WIN32
 #include <sys/mman.h>
+#endif
 #include <errno.h>
 
 #include "trousers/tss.h"
diff --git a/src/tspi/tsp_policy.c b/src/tspi/tsp_policy.c
index 9d5ec5d..c548557 100644
--- a/src/tspi/tsp_policy.c
+++ b/src/tspi/tsp_policy.c
@@ -9,15 +9,26 @@
  */
 
 
+#ifdef WIN32
+#include <ws2tcpip.h>
+#include <windows.h>
+#endif
 #include <stdlib.h>
 #include <stdio.h>
 #include <string.h>
 #include <time.h>
 #include <errno.h>
+#ifndef WIN32
 #include <unistd.h>
+#endif
 #include <sys/types.h>
+#ifndef WIN32
 #include <sys/mman.h>
+#endif
 
+#ifdef __MINGW32__
+#include <stdint.h>
+#endif
 #include "trousers/tss.h"
 #include "trousers/trousers.h"
 #include "trousers_types.h"
@@ -25,8 +36,15 @@
 #include "capabilities.h"
 #include "tsplog.h"
 #include "obj.h"
+#ifdef WIN32
+#include "libc_interface.h"
+#endif
 
+#if defined _SC_PAGESIZE
 #define	PGSIZE sysconf(_SC_PAGESIZE)
+#else
+#define PGSIZE 4096
+#endif
 #define PGOFFSET (PGSIZE - 1)
 #define PGMASK (~PGOFFSET)
 
@@ -86,11 +104,13 @@ popup_GetSecret(UINT32 new_pin, UINT32 hash_mode, BYTE *popup_str, void *auth_ha
 int
 pin_mem(void *addr, size_t len)
 {
+#ifdef FIXME
 	/* only root can lock pages into RAM */
 	if (getuid() != (uid_t)0) {
 		LogWarn("Not pinning secrets in memory due to insufficient perms.");
 		return 0;
 	}
+#endif
 
 	len += (uintptr_t)addr & PGOFFSET;
 	addr = (void *)((uintptr_t)addr & PGMASK);
@@ -105,10 +125,12 @@ pin_mem(void *addr, size_t len)
 int
 unpin_mem(void *addr, size_t len)
 {
+#ifdef FIXME
 	/* only root can lock pages into RAM */
 	if (getuid() != (uid_t)0) {
 		return 0;
 	}
+#endif
 
 	len += (uintptr_t)addr & PGOFFSET;
 	addr = (void *)((uintptr_t)addr & PGMASK);
diff --git a/src/tspi/tsp_ps.c b/src/tspi/tsp_ps.c
index 96c267a..06cdf87 100644
--- a/src/tspi/tsp_ps.c
+++ b/src/tspi/tsp_ps.c
@@ -11,10 +11,14 @@
 #include <limits.h>
 #include <stdlib.h>
 #include <sys/types.h>
+#ifndef WIN32
 #include <sys/file.h>
+#endif
 #include <errno.h>
 #include <string.h>
+#ifndef WIN32
 #include <unistd.h>
+#endif
 #include <stdio.h>
 #include <limits.h>
 
diff --git a/src/tspi/tsp_quote.c b/src/tspi/tsp_quote.c
index 24e026b..3d92c66 100644
--- a/src/tspi/tsp_quote.c
+++ b/src/tspi/tsp_quote.c
@@ -11,7 +11,9 @@
 #include <stdlib.h>
 #include <stdio.h>
 #include <string.h>
+#ifndef WIN32
 #include <inttypes.h>
+#endif
 
 #include "trousers/tss.h"
 #include "trousers/trousers.h"
diff --git a/src/tspi/tsp_quote2.c b/src/tspi/tsp_quote2.c
index 76ccc2e..325bfc8 100644
--- a/src/tspi/tsp_quote2.c
+++ b/src/tspi/tsp_quote2.c
@@ -11,7 +11,9 @@
 #include <stdlib.h>
 #include <stdio.h>
 #include <string.h>
+#ifndef WIN32
 #include <inttypes.h>
+#endif
 
 #include "trousers/tss.h"
 #include "trousers/trousers.h"
diff --git a/src/tspi/tsp_random.c b/src/tspi/tsp_random.c
index 80aff66..33ae715 100644
--- a/src/tspi/tsp_random.c
+++ b/src/tspi/tsp_random.c
@@ -10,8 +10,10 @@
 
 
 #include <stdlib.h>
+#ifndef WIN32
 #include <syslog.h>
 #include <unistd.h>
+#endif
 
 #include "trousers/tss.h"
 #include "trousers/trousers.h"
diff --git a/src/tspi/tsp_selftest.c b/src/tspi/tsp_selftest.c
index 5a27110..650648b 100644
--- a/src/tspi/tsp_selftest.c
+++ b/src/tspi/tsp_selftest.c
@@ -11,7 +11,9 @@
 #include <stdlib.h>
 #include <stdio.h>
 #include <string.h>
+#ifndef WIN32
 #include <inttypes.h>
+#endif
 
 #include "trousers/tss.h"
 #include "trousers/trousers.h"
diff --git a/src/tspi/tspi_admin.c b/src/tspi/tspi_admin.c
index a20ab45..e6e0c55 100644
--- a/src/tspi/tspi_admin.c
+++ b/src/tspi/tspi_admin.c
@@ -11,7 +11,9 @@
 #include <stdlib.h>
 #include <stdio.h>
 #include <string.h>
+#ifndef WIN32
 #include <inttypes.h>
+#endif
 
 #include "trousers/tss.h"
 #include "trousers/trousers.h"
diff --git a/src/tspi/tspi_aik.c b/src/tspi/tspi_aik.c
index 9476341..dd0be79 100644
--- a/src/tspi/tspi_aik.c
+++ b/src/tspi/tspi_aik.c
@@ -12,7 +12,9 @@
 #include <stdlib.h>
 #include <stdio.h>
 #include <string.h>
+#ifndef WIN32
 #include <inttypes.h>
+#endif
 #include <limits.h>
 
 #include "trousers/tss.h"
diff --git a/src/tspi/tspi_asn1.c b/src/tspi/tspi_asn1.c
index f17ce41..fc4e07c 100644
--- a/src/tspi/tspi_asn1.c
+++ b/src/tspi/tspi_asn1.c
@@ -9,6 +9,10 @@
  */
 
 
+#ifdef WIN32
+#include <windows.h>
+#define UINT16_MAX 0xffff
+#endif
 #include <stdlib.h>
 #include <stdio.h>
 #include <string.h>
@@ -17,8 +21,10 @@
 #include <openssl/asn1t.h>
 
 #ifndef TSS_BUILD_ASN1_OPENSSL
+#ifndef WIN32
 #include <arpa/inet.h>
 #endif
+#endif
 
 #include "trousers/tss.h"
 #include "trousers/trousers.h"
diff --git a/src/tspi/tspi_caps_tpm.c b/src/tspi/tspi_caps_tpm.c
index 131e67b..0d36e33 100644
--- a/src/tspi/tspi_caps_tpm.c
+++ b/src/tspi/tspi_caps_tpm.c
@@ -8,10 +8,15 @@
  *
  */
 
+#ifdef WIN32
+#include <windows.h>
+#endif
 #include <stdlib.h>
 #include <stdio.h>
 #include <string.h>
+#ifndef WIN32
 #include <inttypes.h>
+#endif
 
 #include "trousers/tss.h"
 #include "trousers/trousers.h"
diff --git a/src/tspi/tspi_cmk.c b/src/tspi/tspi_cmk.c
index 6ced203..94ce1ec 100644
--- a/src/tspi/tspi_cmk.c
+++ b/src/tspi/tspi_cmk.c
@@ -12,7 +12,9 @@
 #include <stdlib.h>
 #include <stdio.h>
 #include <string.h>
+#ifndef WIN32
 #include <inttypes.h>
+#endif
 
 #include "trousers/tss.h"
 #include "trousers/trousers.h"
diff --git a/src/tspi/tspi_delegate.c b/src/tspi/tspi_delegate.c
index c8fcb6a..c7c1303 100644
--- a/src/tspi/tspi_delegate.c
+++ b/src/tspi/tspi_delegate.c
@@ -12,7 +12,9 @@
 #include <stdlib.h>
 #include <stdio.h>
 #include <string.h>
+#ifndef WIN32
 #include <inttypes.h>
+#endif
 
 #include "trousers/tss.h"
 #include "trousers/trousers.h"
diff --git a/src/tspi/tspi_dir.c b/src/tspi/tspi_dir.c
index 10c0c38..b27aa3a 100644
--- a/src/tspi/tspi_dir.c
+++ b/src/tspi/tspi_dir.c
@@ -11,7 +11,9 @@
 #include <stdlib.h>
 #include <stdio.h>
 #include <string.h>
+#ifndef WIN32
 #include <inttypes.h>
+#endif
 
 #include "trousers/tss.h"
 #include "trousers/trousers.h"
diff --git a/src/tspi/tspi_ek.c b/src/tspi/tspi_ek.c
index d1b2065..ce10d51 100644
--- a/src/tspi/tspi_ek.c
+++ b/src/tspi/tspi_ek.c
@@ -11,7 +11,9 @@
 #include <stdlib.h>
 #include <stdio.h>
 #include <string.h>
+#ifndef WIN32
 #include <inttypes.h>
+#endif
 
 #include "trousers/tss.h"
 #include "trousers/trousers.h"
diff --git a/src/tspi/tspi_maint.c b/src/tspi/tspi_maint.c
index 5576ed3..ead5482 100644
--- a/src/tspi/tspi_maint.c
+++ b/src/tspi/tspi_maint.c
@@ -11,7 +11,9 @@
 #include <stdlib.h>
 #include <stdio.h>
 #include <string.h>
+#ifndef WIN32
 #include <inttypes.h>
+#endif
 
 #include "trousers/tss.h"
 #include "trousers/trousers.h"
diff --git a/src/tspi/tspi_migration.c b/src/tspi/tspi_migration.c
index 83b73f4..63fb407 100644
--- a/src/tspi/tspi_migration.c
+++ b/src/tspi/tspi_migration.c
@@ -11,7 +11,9 @@
 #include <stdlib.h>
 #include <stdio.h>
 #include <string.h>
+#ifndef WIN32
 #include <inttypes.h>
+#endif
 
 #include "trousers/tss.h"
 #include "trousers/trousers.h"
diff --git a/src/tspi/tspi_nv.c b/src/tspi/tspi_nv.c
index 4789cb2..8fd4ffa 100644
--- a/src/tspi/tspi_nv.c
+++ b/src/tspi/tspi_nv.c
@@ -29,7 +29,9 @@
 #include <stdlib.h>
 #include <stdio.h>
 #include <string.h>
+#ifndef WIN32
 #include <inttypes.h>
+#endif
 
 #include "trousers/tss.h"
 #include "trousers/trousers.h"
@@ -130,9 +132,12 @@ Tspi_NV_DefineSpace(TSS_HNVSTORE hNvstore,	/* in */
 	free_tspi(tspContext, pWritePCR);
 
 	if ((result = authsess_xsap_init(tspContext, hTpm, hNvstore, need_authdata,
-					 TPM_ORD_NV_DefineSpace, TPM_ET_OWNER, &xsap)))
+					 TPM_ORD_NV_DefineSpace, TPM_ET_OWNER, &xsap))) {
+		if (result == TSPERR(TSS_E_TSP_AUTHREQUIRED))
+			result = TSS_ERROR_CODE(TSS_E_BAD_PARAMETER);
 		return result;
-
+	}
+	
 	result = Trspi_HashInit(&hashCtx, TSS_HASH_SHA1);
 	result |= Trspi_Hash_UINT32(&hashCtx, TPM_ORD_NV_DefineSpace);
 	result |= Trspi_HashUpdate(&hashCtx, NVPublic_DataSize, NVPublicData);
diff --git a/src/tspi/tspi_own.c b/src/tspi/tspi_own.c
index ef6a44c..a9c669b 100644
--- a/src/tspi/tspi_own.c
+++ b/src/tspi/tspi_own.c
@@ -11,7 +11,9 @@
 #include <stdlib.h>
 #include <stdio.h>
 #include <string.h>
+#ifndef WIN32
 #include <inttypes.h>
+#endif
 
 #include "trousers/tss.h"
 #include "trousers/trousers.h"
diff --git a/src/tspi/tspi_pcr_events.c b/src/tspi/tspi_pcr_events.c
index c860715..e00c924 100644
--- a/src/tspi/tspi_pcr_events.c
+++ b/src/tspi/tspi_pcr_events.c
@@ -11,7 +11,9 @@
 #include <stdlib.h>
 #include <stdio.h>
 #include <string.h>
+#ifndef WIN32
 #include <inttypes.h>
+#endif
 
 #include "trousers/tss.h"
 #include "trousers/trousers.h"
diff --git a/src/tspi/tspi_pcr_extend.c b/src/tspi/tspi_pcr_extend.c
index 6193fd2..6dd07d2 100644
--- a/src/tspi/tspi_pcr_extend.c
+++ b/src/tspi/tspi_pcr_extend.c
@@ -12,7 +12,9 @@
 #include <stdlib.h>
 #include <stdio.h>
 #include <string.h>
+#ifndef WIN32
 #include <inttypes.h>
+#endif
 
 #include "trousers/tss.h"
 #include "trousers/trousers.h"
diff --git a/src/tspi/tspi_quote.c b/src/tspi/tspi_quote.c
index 58d5de0..4bc69b2 100644
--- a/src/tspi/tspi_quote.c
+++ b/src/tspi/tspi_quote.c
@@ -11,7 +11,9 @@
 #include <stdlib.h>
 #include <stdio.h>
 #include <string.h>
+#ifndef WIN32
 #include <inttypes.h>
+#endif
 
 #include "trousers/tss.h"
 #include "trousers/trousers.h"
diff --git a/src/tspi/tspi_quote2.c b/src/tspi/tspi_quote2.c
index 67d4dc1..b5e2ba4 100644
--- a/src/tspi/tspi_quote2.c
+++ b/src/tspi/tspi_quote2.c
@@ -11,7 +11,9 @@
 #include <stdlib.h>
 #include <stdio.h>
 #include <string.h>
+#ifndef WIN32
 #include <inttypes.h>
+#endif
 
 #include "trousers/tss.h"
 #include "trousers/trousers.h"
diff --git a/src/tspi/tspi_random.c b/src/tspi/tspi_random.c
index 9fe8c27..d810b86 100644
--- a/src/tspi/tspi_random.c
+++ b/src/tspi/tspi_random.c
@@ -11,7 +11,9 @@
 #include <stdlib.h>
 #include <stdio.h>
 #include <string.h>
+#ifndef WIN32
 #include <inttypes.h>
+#endif
 
 #include "trousers/tss.h"
 #include "trousers/trousers.h"
diff --git a/src/tspi/tspi_selftest.c b/src/tspi/tspi_selftest.c
index 2cd31d2..f679110 100644
--- a/src/tspi/tspi_selftest.c
+++ b/src/tspi/tspi_selftest.c
@@ -11,7 +11,9 @@
 #include <stdlib.h>
 #include <stdio.h>
 #include <string.h>
+#ifndef WIN32
 #include <inttypes.h>
+#endif
 
 #include "trousers/tss.h"
 #include "trousers/trousers.h"
diff --git a/src/tspi/tspi_transport.c b/src/tspi/tspi_transport.c
index bd956cd..5c27685 100644
--- a/src/tspi/tspi_transport.c
+++ b/src/tspi/tspi_transport.c
@@ -12,7 +12,9 @@
 #include <stdlib.h>
 #include <stdio.h>
 #include <string.h>
+#ifndef WIN32
 #include <inttypes.h>
+#endif
 
 #include "trousers/tss.h"
 #include "trousers/trousers.h"
diff --git a/src/win32/Makefile.am b/src/win32/Makefile.am
new file mode 100644
index 0000000..f2b71bf
--- /dev/null
+++ b/src/win32/Makefile.am
@@ -0,0 +1,6 @@
+noinst_LTLIBRARIES=libc_interface.la
+
+libc_interface_la_SOURCES=libc_interface.c win32dep.c
+
+libc_interface_la_CFLAGS=-DAPPID=\"WIN32LIB\" -I${top_srcdir}/src/include
+libc_interface_la_LDFLAGS="-lws2_32 -luserenv"
